﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.system.threadpool;
// ダミー
private import std.thread;
private import pes.queue;
//private import pes.system.task;

public alias	Queue!(Thread)	ThreadPool;

class ThreadQueue
{
protected:
	ThreadPool[uint]	m_waiter;

public:
	void create(uint id)
	in {
		assert((id in m_waiter) == null);
	}
	body {
		m_waiter[id] = new ThreadPool;
	}
	
	void push(uint id, Thread thread)
	{
		m_waiter[id].push(thread);
	}
	
	Thread shift(uint id)
	{
		return m_waiter[id].shift;
	}
	
	bool empty(uint id)
	{
		return m_waiter[id].empty;
	}
	
	void rehash()
	{
		m_waiter.rehash;
	}
	
	uint[] keys()
	{
		return m_waiter.keys;
	}
}
