﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
 
import 	std.conv,
		std.cstream,
		std.path,
		std.thread,
		std.gc;
		
import task.uitask;
import task.guitask;
import pes.system.delay;
import pes.system.task;
import pes.dump;

pragma(lib, "WS2_32.LIB");	// socket用

const uint DUMMY_PORT = 0;

int main(char[][] argv)
{
//	if (argv.length <= 2) {
//		derr.writef("usage: %s UI_PORT WINNY_PORT\n", getBaseName(argv[0]));
//		return -1;
//	}
//	uint uport = toUint(argv[1]);
//	uint wport = toUint(argv[2]);
	UserInterfaceTask uitask;
	version(Win32) {
//		uitask = new GraphicalUserInterfaceTask(uport, wport);
		uitask = new GraphicalUserInterfaceTask(DUMMY_PORT, DUMMY_PORT);
	}
	version(linux) {
//		uitask = new SocketAPIInterfaceTask(uport, wport);
	}
	uitask.start();
	delayTask(1000);
	Thread.getThis.setPriority(Thread.PRIORITY.IDLE);
	uitask.wait();
	
	return 0;
}
